﻿
using System.Collections;
using System;
namespace XamGridFilterTemplateColumn
{
    public class Personne
    {
        //public string Nom { get; set; }
        //public string Prenom { get; set; }
        public FullNom fullNom {get;set;}

        public string Age { get; set; }

        public Address address { get; set; }
        //public string Numero { get; set; }
        //public string TypeVoie { get; set; }
        //public string NomRue { get; set; }
       
    }

    public class FullNom : IComparable
    {
        public string Nom { get; set; }
        public string PreNom { get; set; }

        public FullNom()
        {}

        public FullNom(string nom,string preNom)
        {
            Nom=nom;
            PreNom=preNom;
        }
        public override string  ToString()
        {
 	         return this.Nom + " " + this.PreNom;
        }

                   

        public int CompareTo(object obj)
        {
            if (obj is FullNom)
            {
                FullNom fn = obj as FullNom;
                if (this.Nom == fn.Nom)
                {
                    return string.Compare(this.PreNom, fn.PreNom);
                }
                else
                {
                    return string.Compare(this.Nom, fn.Nom);
                }
            }
            return -1;
        }
    }
    public class Address : IComparable
    {
        public string Numero { get; set; }
        public string TypeVoie { get; set; }
        public string NomRue { get; set; }

        public Address(string nomRue, string numero, string typeVoie )
        {
            Numero = numero;
            TypeVoie = typeVoie;
            NomRue = nomRue;
        }
        public override string ToString()
        {
            return this.Numero + " " + this.TypeVoie + " " + this.NomRue;
        }


        public int Compare(object x, object y)
        {
            if (x is Address && y is Address)
            {
                if (((Address)x).Numero == ((Address)y).Numero)
                {
                    if (((Address)x).TypeVoie == ((Address)y).TypeVoie)
                    {
                      return string.Compare(((Address)x).NomRue, ((Address)y).NomRue);
                    }
                }
                else
                {
                    return string.Compare(((Address)x).Numero, ((Address)y).Numero);
                }
            }

            return - 1;
        }

        public int CompareTo(object obj)
        {
            if (obj is Address)
            {
                Address address = obj as Address;
                if (this.Numero == address.Numero)
                {
                    if (this.TypeVoie == address.TypeVoie)
                    {
                        return string.Compare(this.NomRue, address.NomRue);
                    }
                }
                else
                {
                    return string.Compare(this.Numero, address.Numero);
                }
            }

            return -1;
        }
    }
}
