﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;

namespace XamGridFilterTemplateColumn
{
    public partial class MainPage : UserControl
    {
        public MainPage()
        {
            InitializeComponent();

            var liste = new List<Personne>
                            {
                                new Personne
                                    {
                                        Age = "2",
                                        fullNom = new FullNom("Jean","Mouloud"),
                                        address = new Address("A la halle","6", "Avenue")
                                    },
                                    new Personne
                                    {
                                        Age = "3",
                                        fullNom = new FullNom( "Jean2", "Mouloud2"),
                                        address = new Address("A la halle","65","Boulevard")
                                    },
                                    new Personne
                                    {
                                        Age = "4",
                                        fullNom = new FullNom( "Jean3","Mouloud3"),
                                        address = new Address( "A la halle","78", "Avenue")
                                    }
                            };

            this.xamGrid.ItemsSource = liste;
        }

        private void itemsBox_Loaded(object sender, RoutedEventArgs e)
        {
            ListBox lb = (ListBox)sender;

            string name = lb.Tag as string;

            if (name == "Nom")
                lb.ItemTemplate = (DataTemplate)this.xamGrid.Resources["CoteFilter"];
            else
                lb.ItemTemplate = (DataTemplate)this.xamGrid.Resources["NormalFilter"];
        }
    }
}
